; /**
;   ******************************************************************************
;   *  _ _ _    _ _ _   _ _
;   * |     \  /     |/     \
;   * |      \/           _ _\
;   * |                  /
;   * |         MultiClet
;   * |                  \ _ _
;   * |                      /
;   * |_ _ _|\/|_ _ _|\ _ _ /
;   *
;   * @file    button_led.asm 
;   * @author  Команда разработчиков Мультиклет
;   * @date    13-07-2015
;   * @brief   Пример работы с портом и включение светодиода по кнопке. 
;   *          
;   ******************************************************************************
;   * @attention
;   *
;   * <h2><center>&copy; COPYRIGHT(c) 2015 Multiclet corp.</center></h2>
;   *
;   *  ДАННЫЙ ПРИМЕР НАПИСАН ДЛЯ БЫСТРОГО ОЗНАКОМЛЕНИЯ ПОЛЬЗОВАТЕЛЯ С
;   *  ВОЗМОЖНОСТЯМИ МУЛЬТИКЛЕТОЧНОГО ПРОЦЕССОРА. КОМПАНИЯ МУЛЬТИКЛЕТ НЕ НЕСЁТ
;   *  ОТВЕТСТВЕННОСТИ ЗА ВОЗМОЖНЫЙ ПРЯМОЙ ИЛИ КОСВЕННЫЙ УЩЕРБ, ПРИЧИНЁННЫЙ 
;   *  ИСПОЛЬЗОВАНИЕМ В ПОЛЬЗОВАТЕЛЬСКИХ ПРОДУКТАХ ИНФОРМАЦИИ, СОДЕРЖАЩЕЙСЯ
;   *  В ДАННОМ ПРИМЕРЕ.
;   * 
;   ******************************************************************************
;   */
;файл констант периферии для ассемблера
.include "R1_pcf.inc"

.text

;расположение светодиодов: 
;LED0 - GPIOB(1<<25), LED1 - GPIOB(1<<24), LED2 - GPIOB(1<<23)
;LED3 - GPIOB(1<<27), LED4 - GPIOC(1<<26), LED5 - GPIOB(1<<29)
;LED6 - GPIOB(1<<28), LED7 - GPIOA(1<<25)
;расположение кнопок:
;BOT0 - GPIOE(1<<27), BOT1 - GPIOE(1<<26), BOT2 - GPIOC(1<<8)
;BOT3 - GPIOC(1<<17), BOT4 - GPIOC(1<<25)

;сконфигурируем порт B для LED2 на выход, а порт E для кнопки SW2 и порт C для кнопки SW3 на вход 
config_port:
    rdl GPIOB_DIR ;считываем текущее значение конфигурации порта B на вход и выход
    orl @1, (1<<23) ;формируем значение для включения 23-го разряда порта B на выход
    wrl @1, GPIOB_DIR ;записываем получившееся значение в регистр конфигурации порта B
    rdl GPIOE_DIR 
    andl @1, ~(1<<26) ;формируем значение для включения 26-го разряда порта E на вход
    wrl @1, GPIOE_DIR 
    rdl GPIOC_DIR
    andl @1, ~(1<<8) ;формируем значение для включения 8-го разряда порта С на вход
    wrl @1, GPIOC_DIR 
    jmp wait_sw2 ;осуществляем переход на параграф с анализом кнопки SW2
complete

;анализ кнопки (без устранения дребезга кнопки)
wait_sw2:
    rdl GPIOE_IN ;получаем текущее значение порта E на вход
    andl @1, (1<<26) ;выделяем 26-й разряд
    je @1, led1_on ;если кнопка нажата, то зажигаем светодиод
    jne @2, wait_sw2 ;если кнопка не нажата, то остаемся в этом параграфе
complete

;включение светодиода
led1_on:
    rdl GPIOB_OUT ;считываем текущее значение порта в регистр передаваемых данных порта В
    orl @1, (1<<23) ;формируем значение для включения логической единицы на 23-м разряде порта B
    wrl @1, GPIOB_OUT ;записываем получившееся значение в регистр передаваемых данных порта B
    jmp wait_sw3 ;осуществляем переход на параграф с задержкой
complete

;анализ кнопки (без устранения дребезга кнопки)
wait_sw3:
    rdl GPIOC_IN ;получаем текущее значение порта E на вход
    andl @1, (1<<8) ;выделяем 8-й разряд
    je @1, led1_off ;если кнопка нажата, то гасим светодиод
    jne @2, wait_sw3 ;если кнопка не нажата, то остаемся в этом параграфе
complete

;выключение светодиода
led1_off:
    rdl GPIOB_OUT ;считываем текущее значение порта в регистр передаваемых данных порта В
    andl @1, ~(1<<23) ;формируем значение для выключения логической единицы на 23-м разряде порта B
    wrl @1, GPIOB_OUT ;записываем получившееся значение в регистр передаваемых данных порта B
    jmp wait_sw2 ;осуществляем переход на параграф с задержкой
complete






  


