; /**
;   ******************************************************************************
;   *  _ _ _    _ _ _   _ _
;   * |     \  /     |/     \
;   * |      \/           _ _\
;   * |                  /
;   * |         MultiClet
;   * |                  \ _ _
;   * |                      /
;   * |_ _ _|\/|_ _ _|\ _ _ /
;   *
;   * @file    wdt.asm 
;   * @author  Команда разработчиков Мультиклет
;   * @date    13-07-2015
;   * @brief   Пример работы сторожевого таймера (WDT). 
;   *          
;   ******************************************************************************
;   * @attention
;   *
;   * <h2><center>&copy; COPYRIGHT(c) 2015 Multiclet corp.</center></h2>
;   *
;   *  ДАННЫЙ ПРИМЕР НАПИСАН ДЛЯ БЫСТРОГО ОЗНАКОМЛЕНИЯ ПОЛЬЗОВАТЕЛЯ С
;   *  ВОЗМОЖНОСТЯМИ МУЛЬТИКЛЕТОЧНОГО ПРОЦЕССОРА. КОМПАНИЯ МУЛЬТИКЛЕТ НЕ НЕСЁТ
;   *  ОТВЕТСТВЕННОСТИ ЗА ВОЗМОЖНЫЙ ПРЯМОЙ ИЛИ КОСВЕННЫЙ УЩЕРБ, ПРИЧИНЁННЫЙ 
;   *  ИСПОЛЬЗОВАНИЕМ В ПОЛЬЗОВАТЕЛЬСКИХ ПРОДУКТАХ ИНФОРМАЦИИ, СОДЕРЖАЩЕЙСЯ
;   *  В ДАННОМ ПРИМЕРЕ.
;   * 
;   ******************************************************************************
;   */
;файл констант периферии для ассемблера
.include "R1_pcf.inc"

.text

;расположение светодиодов: 
;LED0 - GPIOB(1<<25), LED1 - GPIOB(1<<24), LED2 - GPIOB(1<<23)
;LED3 - GPIOB(1<<27), LED4 - GPIOC(1<<26), LED5 - GPIOB(1<<29)
;LED6 - GPIOB(1<<28), LED7 - GPIOA(1<<25)

;регистры WDT:
;WDT_CNT - значение периода счетчика(после снятия сигнала сброс устанавливается 0xFFFFFFFF)
;WDT_KEY - регистр переключения режимов (0x3333-выключить WDT, 0x5555 - включить WDT, 
;0xAAAA - сброс WDT, 0xCCCC - разрешение записи периода счетчика)
;WDT_ST - регистр состояния (1 - WDT работает)

;отключение сторожевого таймера (по умолчанию он всегда включен в процессоре)
wdt_off:
	getl 0x00003333 ;загружаем в коммутатор значение
    wrl @1, WDT_KEY ;записываем это значение для отключения WDT
    jmp config_port ;переходим на настройку порта B
complete

;установка периода до сброса, например 0x5FFFF
; wdt_off:
	; getl 0x00003333 ;загружаем в коммутатор значение
    ; wrl @1, WDT_KEY ;записываем это значение для отключения WDT
    ; jmp wdt_cnt_allow ;переходим на разрешение установки периода
; complete

; wdt_cnt_allow:
	; getl 0x0000CCCC ;загружаем в коммутатор значение
    ; wrl @1, WDT_KEY ;записываем это значение для разрешения установки периода WDT
    ; jmp wdt_set_cnt ;переходим на установку периода счетчика
; complete

; wdt_set_cnt:
	; getl 0x000000FF ;загружаем в коммутатор значение
    ; wrl @1, WDT_CNT ;записываем это значение в период счетчика
    ; jmp wdt_on ;переходим на включение WDT
; complete

; wdt_on:
	; getl 0x00005555 ;загружаем в коммутатор значение
    ; wrl @1, WDT_KEY ;записываем это значение для включения WDT
    ; jmp config_port ;переходим на настройку порта B
; complete

;сконфигурируем порт для LED1 на выход 
config_port:
    rdl GPIOB_DIR ;считываем текущее значение конфигурации порта B на вход и выход
    orl @1, (1<<24) ;формируем значение для включения 24-го разряда порта B на выход
    wrl @1, GPIOB_DIR ;записываем получившееся значение в регистр конфигурации порта B
    jmp led1_on ;осуществляем переход на параграф с задержкой
complete

;включение светодиода
led1_on:
    rdl GPIOB_OUT ;считываем текущее значение порта в регистр передаваемых данных порта В
    orl @1, (1<<24) ;формируем значение для включения логической единицы на 24-м разряде порта B
    wrl @1, GPIOB_OUT ;записываем получившееся значение в регистр передаваемых данных порта B
complete






  


