 /**
   ******************************************************************************
   *  _ _ _    _ _ _   _ _
   * |     \  /     |/     \
   * |      \/           _ _\
   * |                  /
   * |         MultiClet
   * |                  \ _ _
   * |                      /
   * |_ _ _|\/|_ _ _|\ _ _ /
   *
   * @file    pwm.c 
   * @author    
   * @date    13-07-2015
   * @brief       (PWM)  BUZZER. 
   *          
   ******************************************************************************
   * @attention
   *
   * <h2><center>&copy; COPYRIGHT(c) 2015 Multiclet corp.</center></h2>
   *
   *         
   *    .    Ѩ
   *        , ͨ 
   *      , 
   *    .
   * 
   ******************************************************************************
   */

//  
#include <R1_ccf.h>
#include <gpio.h>
#include <pwm.h>

/**
 : 
LED0 - GPIOB(1<<25), LED1 - GPIOB(1<<24), LED2 - GPIOB(1<<23)
LED3 - GPIOB(1<<27), LED4 - GPIOC(1<<26), LED5 - GPIOB(1<<29)
LED6 - GPIOB(1<<28), LED7 - GPIOA(1<<25)
 :
SW1 - GPIOE(1<<27), SW2 - GPIOE(1<<26), SW3 - GPIOC(1<<8)
SW4 - GPIOC(1<<17), SW5 - GPIOC(1<<25)
  (PWM):
PWM->CR -   
PWM->INT -  
PWM->CNTVAL -    
PWM->PSC -  
PWM->CNT -   
PWM->CMPCH0...PWM_CMPCH3 -   
 :
0 - GPIOA(1<<26), 1 - GPIOA(1<<25), 2 - GPIOA(1<<24)
3 - GPIOA(1<<23) 
*/

void main()
{  
    GPIOB->DIR |= 1<<25; //  B   LED0  
    GPIOA->BPS |= 1<<26; //  A  0-     

    PWM->CNT = 0xFFFF; //  
    PWM->CMPCH0 = 0x7FFF; //   
    PWM->PSC = 0x10; //  
    
    while(1)
    {	
        if(((GPIOE->IN)&(1<<26)) == 0)	//   SW2
        {
            PWM->CR = 0x100106; //    0  "1",    0 
                                //   - ,   - 
            GPIOB->OUT |= 1<<25; // "1"       LED0
        }
        if(((GPIOC->IN)&(1<<8)) == 0) //   SW3
        {
            PWM->CR = 0x100006; //   0
            GPIOB->OUT &= ~(1<<25); // "0"       LED0
        }
    }
		
}

