//TIMx constant file
#ifndef MC_TIME_H
#define MC_TIME_H


/**
  * @brief  Функция задержки в микросекундах.
  * @param  count : интервал задержки в микросекундах. 
  *   Данный параметр может принимать одно из следующих значений:
  *   0-28633115.
  * @retval Нет
  */
int mc_delay_us(unsigned int count);

/**
  * @brief  Функция задержки в миллисекундах.
  * @param  count : интервал задержки в микросекундах. 
  *   Данный параметр может принимать одно из следующих значений:
  *   0-42949.
  * @retval Нет
  */
void mc_delay_ms(unsigned int count);

/**
  * @brief  Функция запуска таймера для выработки тиков в миллисекундах.
  * @param Нет
  * @retval Нет
  */
void mc_start_tick();
/**
  * @brief  Функция остановки таймера для выработки тиков в миллисекундах.
  * @param  Нет
  * @retval Нет
  */
void mc_stop_tick();

/**
  * @brief  Функция для получения количества тиков в миллисекундах.
  * @param  Нет
  * @retval Количество тиков в миллисекундах
  */
int mc_get_ms_tick();

#endif




























































